import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;


public class ClientViewer extends Frame
   implements ActionListener 
{
  
    InetAddress shost;
    int         sport;
    TextField tf,tf1;    

    public ClientViewer(){

	Panel p = new Panel();
	tf = new TextField("", 10);
	tf1 = new TextField("", 20);
	tf.addActionListener(this);
	p.add(tf);
	p.add(tf1);

	add(p, "North");

    }

    public void actionPerformed(ActionEvent evt) {
	String tfvalue = tf.getText().trim();

	    registerClient(tfvalue);
 
	ClientRecvChannel receiver = new ClientRecvChannel(ClientViewer.this,tfvalue);
	receiver.start();

    }

    public void getHostNamePort() throws IOException{
	//hardcoding, need improve..................
	shost = InetAddress.getByName("birch.csit.fsu.edu");  
	sport = 8585;
    }

    public void registerClient(String port){

	Socket socket = null;
	BufferedOutputStream ds = null;    
    
	try{
	    getHostNamePort();
	    socket = new Socket(shost,sport);
	    ds = new BufferedOutputStream(socket.getOutputStream());
	}catch(Exception e){        
	    System.out.println("err");//
	}

	String datatype = null;
	byte[] databyte = null;
	String iport = port+"\n";

	try{    
	    System.out.println("Viewer: Begin write ...........");
	    datatype = "0\n";
	    databyte = datatype.getBytes();
	    ds.write(databyte, 0, databyte.length);
	    ds.flush();

	    databyte = iport.getBytes();
	    ds.write(databyte, 0, databyte.length);
	    ds.flush();    
	    System.out.println("Viewer: End write");        
	    ds.close();
	    socket.close();
	}catch(Exception e){        
	    e.printStackTrace();
	    System.out.println("err");
	}
    }
  
  
  public synchronized void displayFromThread(String data){
      tf1.setText(data);
  }

    public static void main(String[] args)
    {
	Frame f = new ClientViewer();
	f.setResizable(true);
	f.setSize(400,400);
	f.setVisible(true);
	//f.show();
    }
  
}


